function sumforcesf(block)
    setup(block);

function setup(block)

% Register parameters
block.NumDialogPrms     = 1;
nForces = block.DialogPrm(1).Data;

% INPUT PORTS
block.NumInputPorts  = nForces;
% Forces
for i=1:nForces
    block.InputPort(i).Dimensions  = 3;
    block.InputPort(i).DatatypeID  = 0;  % double
    block.InputPort(i).Complexity  = 'Real';
    block.InputPort(i).DirectFeedthrough = true;
end

block.NumOutputPorts = 1;
block.OutputPort(1).Dimensions  = 3;
block.OutputPort(1).DatatypeID  = 0; % double
block.OutputPort(1).Complexity  = 'Real';



% Register sample times
%  [0 offset]            : Continuous sample time
%  [positive_num offset] : Discrete sample time
%
%  [-1, 0]               : Inherited sample time
%  [-2, 0]               : Variable sample time
block.SampleTimes = [-1 0];

block.SimStateCompliance = 'DefaultSimState';
block.RegBlockMethod('PostPropagationSetup',    @DoPostPropSetup);
block.RegBlockMethod('Start', @Start);
block.RegBlockMethod('Outputs', @Outputs);     % Required
block.RegBlockMethod('Terminate', @Terminate); % Required
%block.SetPreCompInpPortInfoToDynamic;
%block.SetPreCompOutPortInfoToDynamic;

function DoPostPropSetup(block)
block.NumDworks = 1;
block.Dwork(1).Name            = 'nForces';
block.Dwork(1).Dimensions      = 1;
block.Dwork(1).DatatypeID      = 7;      % double
block.Dwork(1).Complexity      = 'Real'; % real
block.Dwork(1).UsedAsDiscState = true;

function Start(block)
    block.Dwork(1).Data = uint32(block.DialogPrm(1).Data);
    

function Outputs(block)
    nForces = block.Dwork(1).Data;
    f = zeros(nForces,3);
    for i=1:nForces
        f(i,:) = block.InputPort(i).Data(1:3)';
    end
    block.OutputPort(1).Data = sum(f);

function Terminate(~)

