function sumtorquesf(block)
setup(block);

function setup(block)

% Register parameters
block.NumDialogPrms     = 1;
nTorques = block.DialogPrm(1).Data;

% INPUT PORTS
block.NumInputPorts  = nTorques*2;
% Forces
for i=1:nTorques
    block.InputPort(2*i-1).Dimensions  = 3;
    block.InputPort(2*i-1).DatatypeID  = 0;  % double
    block.InputPort(2*i-1).Complexity  = 'Real';
    block.InputPort(2*i-1).DirectFeedthrough = true;
    block.InputPort(2*i).Dimensions  = 3;
    block.InputPort(2*i).DatatypeID  = 0;  % double
    block.InputPort(2*i).Complexity  = 'Real';
    block.InputPort(2*i).DirectFeedthrough = true;
end

% Setup port properties to be inherited or dynamic
%block.SetPreCompInpPortInfoToDynamic;
%block.SetPreCompOutPortInfoToDynamic;
block.NumOutputPorts = 1;
block.OutputPort(1).Dimensions  = 3;
block.OutputPort(1).DatatypeID  = 0; % double
block.OutputPort(1).Complexity  = 'Real';

% Register sample times
%  [0 offset]            : Continuous sample time
%  [positive_num offset] : Discrete sample time
%
%  [-1, 0]               : Inherited sample time
%  [-2, 0]               : Variable sample time
block.SampleTimes = [0 0];
block.SimStateCompliance = 'DefaultSimState';
block.RegBlockMethod('PostPropagationSetup',    @DoPostPropSetup);
block.RegBlockMethod('Start', @Start);
block.RegBlockMethod('Outputs', @Outputs);     % Required
block.RegBlockMethod('Terminate', @Terminate); % Required


function DoPostPropSetup(block)
block.NumDworks = 1;
    block.Dwork(1).Name            = 'nTorques';
    block.Dwork(1).Dimensions      = 1;
    block.Dwork(1).DatatypeID      = 7;      % double
    block.Dwork(1).Complexity      = 'Real'; % real
    block.Dwork(1).UsedAsDiscState = true;


function Start(block)
    block.Dwork(1).Data = uint32(block.DialogPrm(1).Data);
    

function Outputs(block)
  nForces = block.Dwork(1).Data;
    f = zeros(nForces,3);
    for i=1:nForces
        f(i,:) = cross(block.InputPort(2*i-1).Data,block.InputPort(2*i).Data);
    end
    block.OutputPort(1).Data = sum(f);

function Terminate(~)

