function [acc, volt_required] = actuationRequirement(f_ng, a_ng, TM, cap)
%ACTUATIONREQUIREMENT Calculates required actuation voltage to keep test mass
% stable
%   Detailed explanation goes here
% Input:
%    [f_ng, a_ng] - ASD (frequencies and amplitudes) of the non gravitational
%    forces that impact the satellite
% Output:
%

%psd = a_ng.^2;
%loglog(fxx_input_forces, psd)

acc = sqrt(trapz(f_ng(10:60),a_ng(10:60).^2)); %mean? acceleration m/s2
forces_ng = acc*TM.mass;
volt_required = cap.voltage_from_force(forces_ng);
end

