function [acc, volt_required] = actuationRequirementSimplified(sat, TM, cap)
%ACTUATIONREQUIREMENT Calculates required actuation voltage to keep test mass
% stable
%   Detailed explanation goes here
% Input:
%    [f_ng, a_ng] - ASD (frequencies and amplitudes) of the non gravitational
%    forces that impact the satellite
% Output:
%

%psd = a_ng.^2;
%loglog(fxx_input_forces, psd)
arguments
sat Satellite
TM TestMass
cap 
end
acc = sat.typicalDragAcc;
volt_required = cap.voltage_from_force(acc*TM.mass);
end

