function asd = AccelerationNoiseASD(freq, variables)
%ACCELERATIONNOISEASD Returns ASD for a frequency input
%   Returns ASD for a frequency input;
%   can return for each axis
    switch variables
        case "x"
            asd = 1./freq;
        case "y"
            asd = 1./freq.^2;
        case "z"
            asd = 1./freq.^3;
        case "theta"
            asd = 1./freq + freq;
        case "psi"
            asd = 1./freq + freq.^3;
        case "phi"
            asd = 10*(freq.^0);
        case "linear"
            asd = (1e-12 * sqrt(...
                (1e-3./freq).^4 ./((1e-5./freq).^4+1) + ...
                1 + (freq/1e-1).^4));
        case "angular"
            asd = (1e-10 * sqrt(...
                (1e-3./freq).^4 ./  ((1e-5./freq).^4+1) +...
                1 + (freq/1e-1).^4)); 
        otherwise
            asd = -1;
    end
end