function blockHandle = setFromFile(model, block, filename)
%SETINJECTIONBLOCK - Sets the initial parameters of a injection block. 
%Sets the initial parameters for one instance of the injection block from
%Acme library. 
%
% Syntax: setInjectionBlock(model, block, mode, varargin)
%
% Inputs:
%    model - Name of the Simulink model, string
%    block - Name of the target instance of the Injection Block, string
%
% See also: createFrequencyArray, createTimeseriesFromASD_ENBW
%
% Author: Arthur Reis
% email: arthur.reis@aei.mpg.de
% Nov 2021; Last revision: 10.Nov.2021;


blockHandle = Simulink.findBlocks(model,'Name',block);
set_param(blockHandle,'FileName',strcat(filename));

end

