function dF = thermalRadiationNoise(A, P, T0, dT, varargin)
%RADIATION Summary of this function goes here
%   Detailed explanation goes here
% INPUT
%    A - area of the faces, m2;
%    P - pressure
%    T0 - temperature of the system
%    dT - difference between average
% OUTPUT

% Reference: Carbone 2007
sig = 5.67e-8;
c = 299792000;
parser = inputParser;
parser.addOptional('kappaRP', 1); % correction factor
parser.parse;
kappaRP = parser.Results.kappaR;

dF = kappaRP*A*8*sig/(3*c)*T0^3*dT;

end

