clear;
acme = AcmeSim('sgrs_12el_6dof_capsens',1e3+1,1e3+1);


%% Accelerometer Parameters 
l = 0.03;
gap = 0.001;
elSides = [l, l, l];
density = 20099;
g = gap;
V_TM = 0.5;
Cf = 10e-12; %F
Kp = 1;
Ki = 0.0;
Kd = 0.2;
%%
% % % If is drag-free:
% driverGain = 0;
% V_TM = 0.5;
% Vp = 0; %V polarizing 

% If is non-drag-free:1000
%driverGain = -1;
%V_TM = 0.5;
%Vp = 0; %V polarizing 

%fCar = 1e5;

%sat = Satellite;
%sat.altitude = 450; %edit here if needed. These are the defaults for GFO
% sat.mass = 470
% sat.Cd = 2.25
% sat.area = 0.9

TM   = acme.addTestMass('TM',l,gap,'density',density);
%el  =      addElectrodeSF(obj, BlockName, Sides, pos0, V_DC, channels, V_ACs)
electrodeInit;
% sumforcemasking(strcat(acme.ModelName, "/sumforcesX"),4);
% sumforcemasking(strcat(acme.ModelName, "/sumforcesall"),3);
%sumtorquemasking(strcat(acme.ModelName, "/sumtorquesX"),4);

% 
% elXA.normal
% elXB.normal
% elXC.normal
% elXD.normal
%eloffset = [1 1 1];
%capXA = acme.addCapacitorSF('capA',elXA, [+l/2, +l/4, 0]);
%capXB = acme.addCapacitorSF('capB',elXB, [+l/2, -l/4, 0]);
%capXC = acme.addCapacitorSF('capC',elXC, [-l/2, +l/4, 0]);
%capXD = acme.addCapacitorSF('capD',elXD, [-l/2, -l/4, 0]);

% capXB = acme.addCapacitorSF('capXB',[elXB,elXBTM]);
% capXC = acme.addCapacitorSF('capXC',[elXC,elXCTM]);
% capXD = acme.addCapacitorSF('capXD',[elXD,elXDTM]);

% TM   = acme.addTestMass('dblInt',side,gap,'density',density);
% el1  = acme.addElectrode('electrode1', elSides, -(side/2 + gap), 0,    0, fCar);
% el2  = acme.addElectrode('electrode2', elSides, -side/2        , 0, V_TM, fCar);
% el3  = acme.addElectrode('electrode3', elSides,  side/2        , 0, V_TM, fCar);
% el4  = acme.addElectrode('electrode4', elSides, +(side/2 + gap), 0,    0, fCar);
% cap1 = acme.addCapacitor('planeCapacitor1', 'ElectrodePair', [el1, el2]);
% cap2 = acme.addCapacitor('planeCapacitor2', 'ElectrodePair', [el3, el4]);
% 
% %CapNoiseASD = @(f) 1.854e-22 ./f + 5.0124e-19; %F/sqrt(hz)
CapNoiseASD = @(f) 51e-9.*f.^0; %F/sqrt(hz)
CapNoiseXTS  = acme.noiseTS(CapNoiseASD);
% 
% VspASD = @(f) 30e-6*f.^0 + 0.7e-8*1./f; %V/sqrt(Hz) Pollack 2008
% 
% CPDnoiseASD = @(f) cap1.force_from_CPD(10e-3)*f.^0; %worst case
% CPDnoiseTS = acme.noiseTS(CPDnoiseASD);
% Cf = 10e-12; %F
CapNoiseASD = @(f) 51e-9.*f.^0; %F/sqrt(hz)
CapNoiseTS  = acme.noiseTS(CapNoiseASD);

CPDnoiseASD = @(f) cap1.force_from_CPD(10e-3)*f.^0; %worst case
CPDnoiseTS = acme.noiseTS(CPDnoiseASD);
Cf = 10e-12; %F

[a, v] = actuationRequirementSimplified(sat,TM,cap1);
ActuationNoiseASD = @(f) v * 1e-6*f.^0; %V/sqrt(hz)
ActuationNoiseTS  = acme.noiseTS(ActuationNoiseASD);
Vx0 = 2*v;
p = 1e-5; %Pa
gasThermalNoiseASD = @(f) gasBrownianNoise(p,acme.T,TM.l.x,TM.gap.x).*f.^0 + TM.mass*1.6e-15./sqrt(f);
gasThermalNoiseTS = acme.noiseTS(gasThermalNoiseASD);
%%
NoiseASD = @(f)  1e-8*f.^0;
XNoiseTS = acme.noiseTS(NoiseASD);
YNoiseTS = acme.noiseTS(NoiseASD);
ZNoiseTS = acme.noiseTS(NoiseASD);
%NoiseASD = @(f)  1e-8*f.^0;
RollNoiseTS  = acme.noiseTS(@(f)  1e-10*f.^0);
PitchNoiseTS = acme.noiseTS(@(f)  1e-10*f.^0);
YawNoiseTS   = acme.noiseTS(@(f)  1e-10*f.^0);

Ktranslational = -1e6;
Krot = -1e15;
%%
tic
sim(acme.ModelName)
toc
% %%
 dof = 'x';  
 [noises, sys] = nbFromSimulink(acme.ModelName, acme.Frequencies, 'dof', dof);  
 nb = nbGroupNoises(acme.ModelName, noises, sys);  
% matlabNoisePlot(nb);  
%%

vq = interp1(out.simout.Time,out.simout.Data,acme.Time);
ts = out.simout.Data;%(10000:end);
%vq = interp1(out.simout.Time,mdlOutput.simout.Data,acme.Time);
%ts = out.simout.Data;%(10000:end);
[axx,fxx] = flpsd('ts', vq, acme.flpsdOpts{:});
io(2) = linio(strcat(acme.ModelName,'/BPF4'),1,'output');
io(1) = linio(strcat(acme.ModelName,'/sumforcesall1'),1,'input');
readout2accTF = getTFresponse(acme.ModelName, io, fxx); % 
loglog(fxx,axx)
