clear;
acme = AcmeSim('sgrs_12el',1e1+1,1e1+1);


%% Accelerometer Parameters 
l = 0.03;
gap = 0.001;
elSides = [l, l, l];
density = 20099;
g = gap;
V_TM = 0.5;
Cf = 10e-12; %F
Kp = 10;
Ki = 0.0;
Kd = 0.2;
% Kp = 0
% Ki = 0
% Kd = 0
% %%
% % % If is drag-free:
% driverGain = 0;
% V_TM = 0.5;
% Vp = 0; %V polarizing 

% If is non-drag-free:1000
%driverGain = -1;
%V_TM = 0.5;
%Vp = 0; %V polarizing 

%fCar = 1e5;

%sat = Satellite;
%sat.altitude = 450; %edit here if needed. These are the defaults for GFO
% sat.mass = 470
% sat.Cd = 2.25
% sat.area = 0.9

TM   = acme.addTestMass('TM',l,gap,'density',density);
%el  =      addElectrodeSF(obj, BlockName, Sides, pos0, V_DC, channels, V_ACs)
electrodeInit;
acme.checkBlocks;

% %CapNoiseASD = @(f) 1.854e-22 ./f + 5.0124e-19; %F/sqrt(hz)
% CapNoiseASD = @(f) 51e-9.*f.^0; %F/sqrt(hz)
% CapNoiseTS  = acme.noiseTS(CapNoiseASD);
% 
% VspASD = @(f) 30e-6*f.^0 + 0.7e-8*1./f; %V/sqrt(Hz) Pollack 2008
% 
% CPDnoiseASD = @(f) cap1.force_from_CPD(10e-3)*f.^0; %worst case
% CPDnoiseTS = acme.noiseTS(CPDnoiseASD);
% Cf = 10e-12; %F
%%
NoiseASD = @(f)  1e-8*f.^0;
XNoiseTS = acme.noiseTS(NoiseASD);
YNoiseTS = acme.noiseTS(NoiseASD);
ZNoiseTS = acme.noiseTS(NoiseASD);
%NoiseASD = @(f)  1e-8*f.^0;
RollNoiseTS  = acme.noiseTS(@(f)  1e-10*f.^0);
PitchNoiseTS = acme.noiseTS(@(f)  1e-10*f.^0);
YawNoiseTS   = acme.noiseTS(@(f)  1e-10*f.^0);

%Ktranslational = -1e6;
Ktranslational = 0;
%Krot = -1e15;
Krot = 0
%%
tic
mdlOutput = sim(acme.modelName)
toc
%%
io(2) = linio(strcat(acme.modelName,'/capSumX'),1,'output');
io(1) = linio(strcat(acme.modelName,'/Mux12'),1,'input');
readout2accTF = getTFresponse(acme.modelName, io, acme.frequencies); % 
%%
vq = interp1(mdlOutput.diffcapacitance.Time,mdlOutput.diffcapacitance.Data(:,1),acme.time);
%ts = mdlOutput.simout.Data;%(10000:end);
[axx,fxx] = flpsd('ts', vq, acme.flpsdOpts{:});
readout2accTF = getTFresponse(acme.modelName, io, fxx); 
r = readout2accTF(1,:)';
loglog(fxx, axx.*r )
%%
% NoiseBudget demo: free-running calibration 
  % Click on this annotation to run the following:  
 % mdl = 'OLvsCL';  
 % dof = 'OL displacement';  
  freq = logspace(-3, 1, 100);  
  [noises, sys] = nbFromSimulink(acme.modelName, freq, 'dof', 'x');  
  nb = nbGroupNoises(acme.modelName, noises, sys);  
  matlabNoisePlot(nb);  
  
%%

t = tiledlayout(3,2);

% Top plot
ax1 = nexttile;
plot(out.tout, out.forces.Data(:,1));
title(ax1, 'force X');
ylabel(ax1, 'N')

%ax1.YLim = [-1.5e-10 1.5e-10];

ax2 = nexttile;
plot(out.tout, out.torques.Data(:,1))
title(ax2, 'torque roll');
ylabel(ax2, 'Nm')
%ax2.YLim = [-1.5e-10 1.5e-10];

ax3 = nexttile;
plot(out.tout, out.forces.Data(:,2))
title(ax3, 'force y');
ylabel(ax3, 'N');
%ax3.YLim = [-1.5e-10 1.5e-10];
% Bottom plot
ax4 = nexttile;
plot(out.tout, out.torques.Data(:,2))
title(ax4, 'torque pitch');
ylabel(ax4, 'Nm');
%ax4.YLim = [-1.5e-10 1.5e-10];
ax5 = nexttile;
plot(out.tout, out.forces.Data(:,3))
title(ax5, 'force z');
ylabel(ax5, 'N');
xlabel(ax5, 's')
%ax5.YLim = [-1.5e-10 1.5e-10];
ax6 = nexttile;
plot(out.tout, out.torques.Data(:,3))
title(ax6, 'torque yaw');
ylabel(ax6, 'Nm');
xlabel(ax6, 's')
%ax6.YLim = [-1.5e-10 1.5e-10];

linkaxes([ax1,ax3,ax5],'x');
linkaxes([ax2,ax4,ax6],'x');
title(t,"Resulting forces and torques on the TM after 1nN step @ 10s in X axis");