%G = 40;

Vtm = .50;
Vact = 12;
m = 0.54;
A= (0.021)^2;
eps0 = 8.89e-12;
Cf = 10e-12;
d = 0.001;
C0 = 3.9e-12;
freqs = logspace(-5,0,100);
SensVoltNoise = 51e-9;
ActVoltNoise  = 20e-6;

SensorOut2Acc      = tf([-m*Cf*d^3 0 2*eps0*A*Cf*Vtm^2]./m,[2*eps0*A*d*Vtm]); 
SensorOut2Acc_0Vtm = tf([-m*Cf*d^3 0                 0]./m,[2*eps0*A*d*Vtm]); 

SO2Afreq   = frd(SensorOut2Acc     , freqs, 'unit', 'Hz');
SO2A0Vfreq = frd(SensorOut2Acc_0Vtm, freqs, 'unit', 'Hz');

SO2Afreq   = squeeze(abs(SO2Afreq.ResponseData));
SO2A0Vfreq = squeeze(abs(SO2A0Vfreq.ResponseData));

loglog(freqs,SensVoltNoise*SO2Afreq  ,'r','DisplayName','Cap Sensor Noise 100x Vtm')
hold on
loglog(freqs,SensVoltNoise*SO2A0Vfreq,'b','DisplayName','Cap Sensor 100x Vtm, no stiffness')

thermalasd_fromdavila = @(f) 4e-13 *sqrt(1 + 700e-6./f + (300e-6./f).^2);

Act2Acc = tf(-2*eps0*A*Vact ,m*d^2);
Act2AccFreq = frd(Act2Acc, freqs, 'unit', 'Hz');
Act2AccFreq = squeeze(abs(Act2AccFreq.ResponseData));
loglog(freqs, thermalasd_fromdavila(freqs),'--','DisplayName','Thermal Noise')
loglog(freqs, ActVoltNoise*Act2AccFreq,'--','DisplayName','Actuation noise')
legend()
xlabel('Frequency [Hz]');
xlim([1e-4 1e-1]);
ylim([1e-15 1e-10]);
ylabel('acceleration ASD [m/s2 sqrt(hz)]');
title('SGRS Noise budget, cap sensor comparison')



%%
% x = tf(1.3e-10*[1 0 -1e-6/m],[1]); %acc noise from the 51nV/sqrtHz contribution
% freqs = logspace(-5,0,100);
% xtoacc = frd(x, freqs, 'unit', 'Hz');
% xtoacc = squeeze(abs(xtoacc.ResponseData));
% loglog(freqs,xtoacc,'DisplayName','charge amplifier voltage noise')
% 
% k = 2*eps0*A*Vtm^2/d^3

%%
2*eps0*A*Vtm^2/d^3
f = sqrt(2*eps0*A*Vtm^2/d^3/m)/(2*pi)