%% Example 07
% Simulink Noise Budget
% These blocks are from https://github.com/cwipf/SimulinkNb
clear;

mdl = 'ex_05a_noise_budget';
load_system(mdl);
%% Accelerometer Parameters
% TM  
mass = 1; % kg

% control
Kp = 1;
Ki = 0;
Kd = 0;

%% simulation parameters
% there is a difference between open and closed loop sink
freq = logspace(-2, 0, 100);  
sensorNoiseASD = 1e-9 * freq.^-1;
dof = 'x';  
%%
[noises, sys] = nbFromSimulink(mdl, freq, 'dof', dof);  
nb = nbGroupNoises(mdl, noises, sys);  
matlabNoisePlot(nb);  
  
%%
mdl = 'ex_05b_noise_budget';
[noises, sys] = nbFromSimulink(mdl, freq, 'dof', dof);  
nb = nbGroupNoises(mdl, noises, sys);  
matlabNoisePlot(nb);  