function sensorASDexp = getSGRSCapSensorASD(acme, TM, C0, Cf, IAGain,chargeAmpNoiseLevel)
%GETSGRSCAPSENSORASD Summary of this function goes here
%   Detailed explanation goes here



 %C0% F, capacitance between tm and elec. when dx = 0
%fTypical = 1e-2; %Hz
Cf =  10e-12; %F feedback capacitor
%% Voltage Reference
Vd = 5; % Vpp
fDetection = 1e5; %Hz 
capAttenuation = 0.1; 


%% Amplifier

chargeAmpNoiseASD = @(f) chargeAmpNoiseLevel.*f.^0; %V/sqrtHz
assignin('base','chargeAmpNoiseASD',chargeAmpNoiseASD);
assignin('base','IA_BPF_gain',IAGain);
assignin('base','nominal_cap',C0);
assignin('base','Cf',Cf);
assignin('base','fDetection',fDetection);
assignin('base','capAttenuation',capAttenuation);
assignin('base','Vd',Vd);



%% Noise Budget
% this uses the SimulinkNB toolbox.
% it doesn't run the simulation. Instead, it finds the transfer functions of the
% linearized model and plots the noise budged
load_system('sgrs_capSensor')
[noises, sys] = nbFromSimulink('sgrs_capSensor', acme.Frequencies, 'dof', 'x');  
nb = nbGroupNoises('sgrs_capSensor', noises, sys);  
  

%% Expression for the total noise ASD
% assuming ASD = A/f + B, where B is the high freq limit
x = nb.sumNoise.f';
y = nb.sumNoise.asd';
sensorASDexp = fit(x,y, fittype(str2func(['@(a, x) a./x + ' num2str(y(end))])));
clear('chargeAmpNoiseASD','IA_BPF_gain','nominal_cap');
end

