stopTime = 100;
nSteps = 100;
acmeInstance = AcmeSim('dummymodel',stopTime,nSteps);
%% test create object with default settings
assert(isa(acmeInstance,"AcmeSim"),"")
assert(acmeInstance.stopTime == stopTime, "Stop Time not ok")
assert(acmeInstance.nSteps == nSteps, "n steps not ok")

% test setters and getters
% acmeInstance.stopTime
%% test AcmeSim - class constructor.
%

%% test openModel - opens Simulink with the loaded acme model.
a = acmeInstance.openModel;
assert(bdIsLoaded(acmeInstance.modelName), "model not loaded")
%%  addTestMass - Add component TestMass to this Acme instance.
side = .03;
gap = 1e-3;
TM = acmeInstance.addTestMass('TMdyn', side, gap, 'mass', 0.5);

assert(isa(TM,"TestMass"),"")
assert(TM.mass == str2double(TM.get_param('mass_0')))

TM.mass = .8;
assert(TM.mass == str2double(TM.get_param('mass_0')))
%TM.blockHan
%% test addElectrode - Add component Electrode to this Acme instance.
l = side;          %BlockName, LengthSides, pos0, V_DC,...
g = gap;
Vx = 10;
EL = acmeInstance.addElectrode('elA2', [0,l/2,l], [+(l/2+g), -l/4, 0], Vx, ["x"], [0]);

assert(isa(EL,"Electrode"),"")

EL1 = acmeInstance.addElectrode('elA', [0,l/2,l], [+(l/2+g), -l/4, 0], Vx, ...
	["x"], [0]);
EL2 = acmeInstance.addElectrode('elA1', [0,l/2,l], [+(l/2+g), -l/4, 0], Vx, ...
	["x","y"], [0 0 0 ]);
EL3 = acmeInstance.addElectrode('elA2', [0,l/2,l], [+(l/2+g), -l/4, 0], Vx, ...
	["x","y","z"], [0 0 0]);
EL3 = acmeInstance.addElectrode('elA3', [0,l/2,l], [+(l/2+g), -l/4, 0], Vx, ...
	["x","y","z"], [0 0 0]);

cap1 = acmeInstance.addCapacitor('cap1', EL1)
cap2 = acmeInstance.addCapacitor('cap2', EL2)
   %             channels, V_ACs
%% addCapacitor - Add component Capacitor to this Acme instance.

%%  addTestMass - Add component TestMass to this Acme instance.

%%  addCapacitorSF - add Capacitor (S-Function) to this Acme instance.

%%  addElectrodeSF - Add Electrode (S-Function) to this Acme instance.