l = 0.03;
g = 0.001;
TM_size = [l, l, l]; % [1x3] double, (Lx, Ly, Lz);
TM_gaps = [g, g, g]; % [1x3] double;

el_areas = l*l/2*[1 1 1; %XA/D YA/D ZA/D   
                  1 1 1];%XB/C YB/C ZB/C  [2x3] double;

%                x         y   z    
el_pos = [+(l/2+g),     -l/4,  0 %XA %  m, [12x3] double;
          +(l/2+g),     +l/4,  0 %XB
          -(l/2+g),     -l/4,  0 %XC
		  -(l/2+g),     +l/4,  0 %XD
		         0, +(l/2+g), -l/4 %YA
                 0, +(l/2+g), +l/4 %YB
       	         0, -(l/2+g), -l/4 %YC
                 0, -(l/2+g), +l/4 %YD
              -l/4,        0, +(l/2+g)  %ZA
              +l/4,        0, +(l/2+g)  %ZB
              -l/4,        0, -(l/2+g)  %ZC
              +l/4,        0, -(l/2+g)];%ZD

TM_shadowPos = [+l/2, -l/4,  0 %  m, [12x3] double;+
                +l/2, +l/4,  0
                -l/2, -l/4,  0
		        -l/2, +l/4,  0
		         0,   +l/2, -l/4
                 0,   +l/2, +l/4
       	         0,   -l/2, -l/4
                 0,   -l/2, +l/4
                -l/4,  0,   +l/2
                +l/4,  0,   +l/2
                -l/4,  0,   -l/2
                +l/4,  0,   -l/2];
eps0 = 8.8e-12;
V_TM = 0.5;
stopTime = 11;
nSteps = 11;
acme = AcmeSim('sgrs_12el_222',stopTime,nSteps);

el222 = ElectrodeHW222('BlockName', 'el222', ...
					   'Model', acme.modelName, ...
					   'TM_size', TM_size, ...
					   'TM_gaps', TM_gaps,...
					   'el_areas', el_areas, ...
					   'el_pos', el_pos, ...
					   'TM_shadowPos',	TM_shadowPos, ...
					   'eps0',eps0)

NoiseASD = @(f)  1e-8*f.^0;
XNoiseTS = acme.noiseTS(NoiseASD);
YNoiseTS = acme.noiseTS(NoiseASD);
ZNoiseTS = acme.noiseTS(NoiseASD);
%NoiseASD = @(f)  1e-8*f.^0;
RollNoiseTS  = acme.noiseTS(@(f)  1e-10*f.^0);
PitchNoiseTS = acme.noiseTS(@(f)  1e-10*f.^0);
YawNoiseTS   = acme.noiseTS(@(f)  1e-10*f.^0);

%Ktranslational = -1e6;
Ktranslational = 0;
%Krot = -1e15;
Krot = 0