clear all;
% ,'BH92', is special, since it has non-zero drop samples
%
% drop samples is not implemented in LTPDA LPSD, but in LTPDA/PSD, and not
% in facade
winL = {'Rectangular','Welch','Bartlett','Hanning','Hamming','Nuttall3','Nuttall4','Nuttall3a','Nuttall3b','Nuttall4a','Nuttall4b','Nuttall4c','SFT3F','SFT3M','FTNI','SFT4F','SFT5F','SFT4M','FTHP','HFT70','FTSRS','SFT5M','HFT90D','HFT95','HFT116D','HFT144D','HFT169D','HFT196D','HFT223D','HFT248D'};
while (true)
    fSample = (rand(1))*1e3;
    N=round(rand(1)*1e5);
    mt = [0:1:N]/fSample;
    fsin = 10^(rand(1))*log10(fSample/2);
    pf1 = randn(1);
    pf2 = randn(1);
    y = randn(size(mt))*sqrt(fSample/2)*1e-3 + sqrt(2)*sin(2*pi*fsin*mt)+ mt*pf1 + mt.^2*pf2;
    
    Kdes = round((rand(1)*200)+1);
    Jdes = round((rand(1)*2000)+1);
    Lmin = 0;
    if round(rand(1))
        mynavs = round(rand(1)*100);
    elseif round(rand(1))
        mynavs = 0;
    else
        mynavs = -1;
    end
    
    if round(rand(1))
        nfft = round(rand(1)*N);
    else
        nfft = -1;
    end
    
    if round(rand(1))
        olap = round(rand(1)*100);
    else
        olap = -1;
    end
    
    order = round(rand(1)*3)-1;
    
    %mywin = 'bh92';
    mywin = winL{ ceil(rand(1)*numel(winL)) };
    ll = {'ASD','PSD','PS','AS'};
    myscale = ll{floor((rand(1))*4)+1};
    ap1 = ao(plist('type','tsdata','yvals', y,'fs', fSample,'yunits','m','name','x'));
    % Compare implementations
    
%       tic
%       [a_org,f_org, enbwcoeff] = flpsd( 'ts', y, 'fs', fSample, 'Kdes', Kdes, 'Lmin', Lmin, ...
%               'Jdes', Jdes, 'win', mywin, 'olap', olap, 'order', order,...
%               'scale', myscale, 'LTPDAmode',false);
%       toc
    tic
    [a_ltp,f_ltp, enbwcoeff2] = flpsd( 'ts', y, 'fs', fSample, 'Kdes', Kdes, 'Lmin', Lmin, ...
        'Jdes', Jdes, 'win', mywin, 'olap', olap, 'order', order,...
        'scale', myscale, 'LTPDAmode',true, 'LTPDAbug',true);
    toc
    tic
    
    aoPSD2 = lpsd([ap1],plist('scale', myscale,'win', mywin, 'order', order,'kdes',Kdes,'jdes',Jdes,'olap',olap));
    toc
    tic
    aoPSD3 = psd([ap1],plist('scale', myscale,'win', mywin,'navs',mynavs,'olap',olap,'order', order, 'nfft', nfft ));
    toc
    tic
    [aoPSD4, fpsd4, enbw] = fpsd( 'ts', y, 'fs', fSample, 'win', mywin, 'olap', olap, 'order', order,...
        'scale', myscale, 'navs', mynavs, 'nfft', nfft );
    toc
    %%
    try
        er1 = fpsd4-aoPSD3.x;
    catch
        numel(fpsd4)
        numel(aoPSD3.x)
        N/mynavs
    end
    er2 = abs((aoPSD4-aoPSD3.y)./aoPSD3.y);
    if er2(1) > 1e-4
        warning('diff PSD first sample: %e', er2(1));
    elseif any(er2(2:end) > 1e-4)
        error('diff PSD: amplitude');
    end
    if any(er1 ~=0)
        error('diff PSD: frequency');
    end
    
    er1 = f_ltp-aoPSD2.x;
    er2 = abs((a_ltp-aoPSD2.y)./aoPSD2.y);
    if any(er2 > 1e-1)
        error('diff LPSD: amplitude');
    end
    if any(er1 ~=0)
        error('diff LPSD: frequency');
    end
    %error('fin');
end % while loope
%% 
figure
%loglog(f_org, a_org); hold on;
loglog(f_ltp, a_ltp, aoPSD2.x, aoPSD2.y);
hold on;
loglog(aoPSD3.x, aoPSD3.y);
loglog(fpsd4, aoPSD4,'g--');
legend('flpsd paper','flpsd rwrt. from LTPDA','LPSD from LTPDA','PSD from LTPDA', 'fpsd');
%loglog(f_org, a_org, f_ltp, a_ltp, aoPSD2.x, aoPSD2.y);
title('Comparison of implementations')
xlabel('Frequency [Hz]')